#!/usr/bin/python
import ensimapplpath
import vh3
import virthost
import virtutil

import sys
import os
import cmdlnpopen 
import popen2

debug = 1 ; #Enabled
FORCEEXIT = -1 ; #ABORT !!!

service_name = 'spam_filter' ;
sa_domains = [] ;
sa_users = [] ;

USER_SA_DIR="/mail/.spamassassin";

def log(error, state, forceexit=0):

    if debug and not forceexit :
     msg = str(error) + ":" + state + "\n";
     sys.stderr.write(msg) ; 

    if forceexit < 0 :
       msg = "EXIT_ON_ERROR:" + str(error) + ":" + state + "\n";
       sys.stderr.write(msg) ; 
       sys.exit(error);
 

def get_spam_enabled_domains(all_domains):

     error = 1 ;
     state = "get_spam_enabled_domains" ;
     log(error,state);

     sa_domains = [] ;
     for domain in all_domains:
      if virthost.site_enabled(domain, service_name):
       sa_domains.append(domain) ;

     return sa_domains ;
	

def get_domain_users(sa_domain):
     error = 2 ;
     state = "get_domain_users:" + sa_domain;
     log(error,state);

     domain_users = [] ;
     domain_users = virthost.site_getusers(sa_domain);
     return domain_users ;

def get_sa_users(sa_domain, domain_users):
     error = 3 ;
     state = "get_sa_users:" + sa_domain ;
     log(error,state);

     global sa_users ;
     
     DOMAIN_HOME_PATH = "/home/virtual/" + sa_domain + "/fst/home/" ;

     sa_users = [] ;

     for domain_user in domain_users : 
      USER_DIR = DOMAIN_HOME_PATH + domain_user ;
      if not os.path.exists(USER_DIR):
       state = "get_sa_users:" + USER_DIR + " absent";
       log(error,state);
      else:
       SA_DIR = USER_DIR + "/.spamassassin" ;
       if os.path.exists(SA_DIR):
          sa_users.append(domain_user);
          state = "get_sa_users:" + SA_DIR + ":OK";        
          log(error,state);
       else:
          state = "get_sa_users:" + domain_user + " \'s .spamassassin dir missing";
          log(error,state);
   
     return sa_users ;

def pre_upgrade_process(sa_domain, sa_user):
     error = 4 ;
     state = "pre_upgrade_process" + ":" + sa_domain + ":" + sa_user ;
     log(error, state);

     CHROOT_PATH = "/home/virtual/" + sa_domain + "/fst" ;
     SPAM_FOLDER= CHROOT_PATH + "/" + sa_user + "/.spamassassin" ;
    
     cmd = "/usr/sbin/chroot %s /bin/sh -c \" su - %s -c \\\" sa-learn --rebuild \\\" \" " % (CHROOT_PATH, sa_user) ;

     rebuild_db = popen2.Popen3(cmd);
     rv = rebuild_db.wait();

     state = sa_user + ":" + str(rv) ;
     log(error,state);

def post_upgrade_process(sa_domain, sa_user):
    error = 5 ;
    state = "post_upgrade_process" + ":" + sa_domain + ":" + sa_user ;

    cmd = "/usr/sbin/chroot %s /bin/sh -c \" su - %s -c \\\" sa-learn --import \\\" \""; 
    import_db = popen2.Popen3(cmd);
    rv = import_db.wait();
    state = "import_done:" + str(rv);
    log(error,state);

    cmd = "/usr/sbin/chroot %s /bin/sh -c \" su - %s -c \\\" sa-learn --sync \\\" \""; 
    sync_db = popen2.Popen3(cmd);
    rv = sync_db.wait() ; 
    state = "sync_done:" + str(rv);
    log(error,state);


    
if __name__ == "__main__":

   all_domains = virthost.get_domain_list() ;
   all_domains.sort();

   sa_domains = get_spam_enabled_domains(all_domains);

   for sa_domain in sa_domains:
       domain_users = get_domain_users(sa_domain) ;
       sa_users = get_sa_users(sa_domain, domain_users) ;

       for sa_user in sa_users :
           pre_upgrade_process(sa_domain, sa_user);
